package com.hisschemoller.controller 
{
	import com.hisschemoller.model.SoundProxy;
	import com.hisschemoller.util.sound.SoundVO;
	
	import org.audiofx.mp3.MP3FileReferenceLoader;
	import org.audiofx.mp3.MP3SoundEvent;
	import org.puremvc.as3.interfaces.ICommand;
	import org.puremvc.as3.interfaces.INotification;
	import org.puremvc.as3.patterns.command.SimpleCommand;
	
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.net.FileFilter;
	import flash.net.FileReference;	
	/**
	 * @author Wouter Hisschemoller
	 * (c) Oct 2, 2009
	 */
	public class Mp3SelectCommand extends SimpleCommand implements ICommand 
	{
		private var mMp3Loader : MP3FileReferenceLoader;
		private var mFileReference : FileReference;
		
		override public function execute(inNote : INotification) : void
		{
			mFileReference = new FileReference();
			mFileReference.addEventListener(Event.SELECT, handleFileReferenceSelect);
			mFileReference.addEventListener(Event.CANCEL, handleNoSelection);
			mFileReference.addEventListener(IOErrorEvent.IO_ERROR, handleNoSelection);
			mFileReference.browse([ new FileFilter("MP3 Files", "*.mp3") ]);
			
			mMp3Loader = new MP3FileReferenceLoader();
			mMp3Loader.addEventListener(MP3SoundEvent.COMPLETE, handleMp3LoaderComplete);
		}

		/**
		 * A local file is selected, convert the FileReference.data byteArray to a Sound object
		 */
		private function handleFileReferenceSelect(inEvent : Event) : void
		{
			(facade.retrieveProxy(SoundProxy.NAME) as SoundProxy).clear();
			
			mMp3Loader.getSound(mFileReference);
		}
		
		/**
		 * 
		 */
		private function handleNoSelection(inEvent : Event) : void
		{
			removeListeners();
		}

		/**
		 * 
		 */
		private function handleMp3LoaderComplete(inEvent : MP3SoundEvent) : void
		{
			removeListeners();
			
			var soundVO : SoundVO = new SoundVO();
			soundVO.sound = inEvent.sound;
			
			(facade.retrieveProxy(SoundProxy.NAME) as SoundProxy).changeSound(soundVO);
		}

		/**
		 * 
		 */
		private function removeListeners() : void
		{
			mFileReference.removeEventListener(Event.SELECT, handleFileReferenceSelect);
			mMp3Loader.removeEventListener(MP3SoundEvent.COMPLETE, handleMp3LoaderComplete);
		}
	}
}
