package com.hisschemoller.controller 
{
	import com.hisschemoller.App;
	import com.hisschemoller.AppFacade;
	import com.hisschemoller.model.SoundProxy;
	import com.hisschemoller.view.EditorPanelMediator;
	import com.hisschemoller.view.LoadPanelMediator;
	import com.hisschemoller.view.WaveDisplayMediator;
	
	import org.puremvc.as3.interfaces.ICommand;
	import org.puremvc.as3.interfaces.INotification;
	import org.puremvc.as3.patterns.command.SimpleCommand;	
	/**
	 * (c) Copyright LBi Lost Boys 2009
	 * @author wouter.hisschemoller
	 */
	public class StartupCommand extends SimpleCommand implements ICommand 
	{
		/**
		 * Register the Proxies and Mediators
		 */
		override public function execute(inNote : INotification) : void
		{
			// Create and register proxies
			facade.registerProxy(new SoundProxy());
			
			// Create and register mediators
			var app : App = inNote.getBody() as App;
			facade.registerMediator(new EditorPanelMediator(app.mEditorPanel));
			facade.registerMediator(new LoadPanelMediator(app.mLoadPanel));
			facade.registerMediator(new WaveDisplayMediator(app.mEditorPanel.waveDisplay));
			
			// Start the application by loading a sound.
			facade.sendNotification(AppFacade.MP3_LOAD, "../mp3/supersmokeysoul-track6.mp3");
		}
	}
}
