package com.hisschemoller.view 
{
	import com.hisschemoller.model.SoundProxy;
	import com.hisschemoller.view.components.EditorPanel;

	import org.puremvc.as3.interfaces.IMediator;
	import org.puremvc.as3.interfaces.INotification;
	import org.puremvc.as3.patterns.mediator.Mediator;

	import flash.events.Event;	
	/**
	 * (c) Copyright LBi Lost Boys 2009
	 * @author wouter.hisschemoller
	 */
	public class EditorPanelMediator extends Mediator implements IMediator 
	{
		public static const NAME : String = "EditorPanelMediator";
		private var mSoundProxy : SoundProxy;

		public function EditorPanelMediator(inViewComponent : Object = null)
		{
			super(NAME, inViewComponent);
		}

		/**
		 * 
		 */
		override public function onRegister() : void
		{
			mSoundProxy = facade.retrieveProxy(SoundProxy.NAME) as SoundProxy;
			
			editorPanel.addEventListener(EditorPanel.HORIZONTAL_ZOOM_CHANGE, handleHZoomSliderChange);
			editorPanel.addEventListener(EditorPanel.VERTICAL_ZOOM_CHANGE, handleVZoomSliderChange);
			editorPanel.addEventListener(EditorPanel.POSITION_CHANGE, handlePositionSliderChange);
		}

		/**
		 * 
		 */
		override public function listNotificationInterests() : Array
		{
			return [SoundProxy.SOUND_CHANGED,
					SoundProxy.GRAPHIC_UPDATED];
		}

		/**
		 * 
		 */
		override public function handleNotification(inNote : INotification) : void
		{
			switch(inNote.getName()) 
			{
				case SoundProxy.SOUND_CHANGED:
					editorPanel.updateZoomSliders(mSoundProxy.minSamplesPerPixel, mSoundProxy.maxSamplesPerPixel, mSoundProxy.currentSamplesPerPixel);
					break;
				case SoundProxy.GRAPHIC_UPDATED:
					editorPanel.updatePosition(mSoundProxy.numSamplesInView, mSoundProxy.numSamplesTotal, mSoundProxy.firstSampleInView, mSoundProxy.currentSamplesPerPixel);
					break;
			}
		}

		/**
		 * 
		 */
		private function handleHZoomSliderChange(inEvent : Event) : void
		{
			mSoundProxy.currentSamplesPerPixel = editorPanel.hZoomSliderValue;
		}

		/**
		 * 
		 */
		private function handleVZoomSliderChange(inEvent : Event) : void
		{
			mSoundProxy.verticalZoomLevel = editorPanel.vZoomSliderValue;
		}

		/**
		 * 
		 */
		private function handlePositionSliderChange(inEvent : Event) : void
		{
			mSoundProxy.firstSampleInView = editorPanel.positionScrollBarPosition;
		}

		/**
		 * 
		 */
		private function get editorPanel() : EditorPanel
		{
			return viewComponent as EditorPanel;
		}
	}
}
