package com.hisschemoller.view 
{
	import com.hisschemoller.model.SoundProxy;
	import com.hisschemoller.view.components.WaveDisplay;
	
	import org.puremvc.as3.interfaces.IMediator;
	import org.puremvc.as3.interfaces.INotification;
	import org.puremvc.as3.patterns.mediator.Mediator;
	
	import flash.display.BitmapData;
	import flash.events.Event;
	import flash.events.MouseEvent;	
	/**
	 * (c) Copyright LBi Lost Boys 2009
	 * @author wouter.hisschemoller
	 */
	public class WaveDisplayMediator extends Mediator implements IMediator 
	{
		public static const NAME : String = "WaveDisplayMediator";
		private var mSoundProxy : SoundProxy;

		public function WaveDisplayMediator(inViewComponent : Object)
		{
			super(NAME, inViewComponent);
		}

		/**
		 * 
		 */
		override public function onRegister() : void
		{
			mSoundProxy = facade.retrieveProxy(SoundProxy.NAME) as SoundProxy;
			
			waveDisplay.addEventListener(MouseEvent.MOUSE_DOWN, handleMouseDown);
			waveDisplay.addEventListener(WaveDisplay.MOUSE_DRAG, handleMouseDrag);
		}

		/**
		 * 
		 */
		override public function listNotificationInterests() : Array
		{
			return [SoundProxy.GRAPHIC_UPDATED];
		}

		/**
		 * 
		 */
		override public function handleNotification(inNote : INotification) : void
		{
			switch(inNote.getName()) 
			{
				case SoundProxy.GRAPHIC_UPDATED:
					waveDisplay.bitmapData = inNote.getBody() as BitmapData;
					break;
			}
		}

		/**
		 * 
		 */
		private function handleMouseDown(inEvent : MouseEvent) : void
		{
			mSoundProxy.initializeDrag(waveDisplay.mouseX, waveDisplay.mouseY);
		}

		/**
		 * 
		 */
		private function handleMouseDrag(inEvent : Event) : void
		{
			mSoundProxy.updateDrag(waveDisplay.mouseX, waveDisplay.mouseY);
		}

		/**
		 * 
		 */
		private function get waveDisplay() : WaveDisplay
		{
			return viewComponent as WaveDisplay;
		}
	}
}
