package com.hisschemoller.view.components 
{
	import assets.EditorPanelAsset;
	
	import com.hisschemoller.view.components.base.Component;
	
	import flash.display.DisplayObjectContainer;
	import flash.events.Event;
	import flash.text.TextFieldAutoSize;	
	/**
	 * (c) Copyright LBi Lost Boys 2009
	 * @author wouter.hisschemoller
	 */
	public class EditorPanel extends Component 
	{
		public static const HORIZONTAL_ZOOM_CHANGE : String = "horizontalZoomChange";
		public static const VERTICAL_ZOOM_CHANGE : String = "verticalZoomChange";
		public static const POSITION_CHANGE : String = "positionChange";
		private var mHZoomSlider : HSlider;
		private var mVZoomSlider : HSlider;
		private var mFirstLabel : AlignLeftLabel;
		private var mLastLabel : AlignRightLabel;
		private var mSamplesPerPixelLabel : AlignCenterLabel;
		private var mWaveDisplay : WaveDisplay;
		private var mPositionScrollBar : HScrollBar;

		public function EditorPanel(inContainer : DisplayObjectContainer)
		{
			super(inContainer, new EditorPanelAsset());
		}

		/**
		 * 
		 */
		public function updateZoomSliders(inMinZoom : Number, inMaxZoom : Number, inCurrentZoom : Number) : void
		{
			mHZoomSlider.setSliderProperties(inMinZoom, inMaxZoom, inCurrentZoom);
			mVZoomSlider.value = mVZoomSlider.minimum;
		}

		/**
		 * 
		 */
		public function updatePosition(inNumSamplesInView : int, inNumSamplesTotal : int, inFirstSampleInView : int, inCurrentSamplesPerPixel : Number) : void
		{
			mPositionScrollBar.pageSize = inNumSamplesInView;
			mPositionScrollBar.minScrollPosition = 0;
			mPositionScrollBar.maxScrollPosition = inNumSamplesTotal - inNumSamplesInView;
			mPositionScrollBar.pageScrollSize = inNumSamplesInView * 0.5;
			mPositionScrollBar.scrollPosition = inFirstSampleInView;
			
			mFirstLabel.setText(inFirstSampleInView.toString());
			mLastLabel.setText((inFirstSampleInView + inNumSamplesInView).toString());
			mSamplesPerPixelLabel.setText(inCurrentSamplesPerPixel.toFixed(2));
		}

		/**
		 * 
		 */
		public function get hZoomSliderValue() : Number
		{
			return mHZoomSlider.value;
		}

		/**
		 * 
		 */
		public function get vZoomSliderValue() : Number
		{
			return mVZoomSlider.value;
		}

		/**
		 * 
		 */
		public function get positionScrollBarPosition() : Number
		{
			return mPositionScrollBar.scrollPosition;
		}

		/**
		 * 
		 */
		public function get waveDisplay() : WaveDisplay
		{
			return mWaveDisplay;
		}

		/**
		 * 
		 */
		override protected function addChildren() : void
		{
			mHZoomSlider = new HSlider(asset.tHZoomSliderAsset);
			mHZoomSlider.addEventListener(Event.CHANGE, handleHZoomSliderChange);
			
			mVZoomSlider = new HSlider(asset.tVZoomSliderAsset);
			mVZoomSlider.setSliderProperties(1, 10, 1);
			mVZoomSlider.addEventListener(Event.CHANGE, handleVZoomSliderChange);
			
			mFirstLabel = new AlignLeftLabel(asset.tFirstLabel);
			mFirstLabel.setAutoSize(TextFieldAutoSize.LEFT);
			
			mLastLabel = new AlignRightLabel(asset.tLastLabel);
			mLastLabel.setAutoSize(TextFieldAutoSize.RIGHT);
			
			mSamplesPerPixelLabel = new AlignCenterLabel(asset.tSPPLabel);
			mSamplesPerPixelLabel.setAutoSize(TextFieldAutoSize.CENTER);
			
			mPositionScrollBar = new HScrollBar(asset.tPositionScrollBarAsset);
			mPositionScrollBar.addEventListener(Event.CHANGE, handlePositionScrollBarChange);
			
			mWaveDisplay = new WaveDisplay(asset.tWaveDisplayAsset);
		}

		/**
		 * 
		 */
		private function handleHZoomSliderChange(inEvent : Event) : void
		{
			dispatchEvent(new Event(EditorPanel.HORIZONTAL_ZOOM_CHANGE));
		}

		/**
		 * 
		 */
		private function handleVZoomSliderChange(inEvent : Event) : void
		{
			dispatchEvent(new Event(EditorPanel.VERTICAL_ZOOM_CHANGE));
		}

		/**
		 * 
		 */
		private function handlePositionScrollBarChange(inEvent : Event) : void
		{
			dispatchEvent(new Event(EditorPanel.POSITION_CHANGE));
		}

		/**
		 * 
		 */
		private function get asset() : EditorPanelAsset
		{
			return mAsset as EditorPanelAsset;
		}
	}
}
