package com.hisschemoller.view.components 
{
	import assets.HelpPanelAsset;
	
	import com.hisschemoller.view.components.base.Component;
	import com.hisschemoller.view.components.base.PushButton;
	
	import flash.display.DisplayObjectContainer;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.text.TextField;	
	/**
	 * @author Wouter Hisschemöller
	 * (c) Jul 19, 2009
	 */
	public class Help extends Component 
	{
		public static const CLOSE_CLICK : String = "closeClick";
		private var mCloseButton : PushButton;
		private var mBody : TextField;
		private var mScrollBar : VScrollBar;
		
		public function Help(inContainer : DisplayObjectContainer)
		{
			super(inContainer, new HelpPanelAsset());
		}
		
		/**
		 * 
		 */
		public function show() : void
		{
			mAsset.visible = true;
		}
		
		/**
		 * 
		 */
		public function hide() : void
		{
			mAsset.visible = false;
		}
		
		/**
		 * 
		 */
		override protected function addChildren() : void
		{
			var asset : HelpPanelAsset = HelpPanelAsset(mAsset);
			
			mCloseButton = new PushButton(asset.tCloseButton);
			mCloseButton.addEventListener(MouseEvent.CLICK, handleCloseClick);
			
			var helpText : String = "This application loads an MP3 file and shows the wave form. It makes no sound. A simple waveform display like this might be a useful component in a larger application where audio needs to be edited. Here it's on its own because I'm figuring out how to best program such a component. So this application is more experimental than useful.";
			helpText += "<br><br>";
			helpText += "<font size='16'>How it works</font><br>";
			helpText += "A default MP3 file is loaded and displayed at startup. But you can load your own MP3. Click the 'load mp3' button and browse to an MP3 file on your computer. Opening a large MP3 file might take a long time however. Best to try with short files. Less than one minute for example.";
			helpText += "<br><br>";
			helpText += "<font size='16'>Controls</font><br>";
			helpText += "<li>Once loaded the complete waveform is shown from start to end.</li>";
			helpText += "<li>You can zoom in to a detail of the waveform with the 'zoom horizontal' slider.</li>";
			helpText += "<li>When zoomed in you can move through the waveform with the scrollbar directly under the waveform.</li>";
			helpText += "<li>Drag the mouse on the waveform to move through the waveform more precise.</li>";
			helpText += "<li>You can magnify the waveform vertically with the 'zoom vertical' slider. This is useful to inspect very quiet parts of the sound.</li>";
			helpText += "<br><br>";
			helpText += "<font size='16'>About the display</font><br>";
			helpText += "<li>In Flash sounds have a sample frequency (sample rate) of 44100 samples per second. Which is the same as audio CDs and sort of a standard sample rate.</li>";
			helpText += "<li>At the highest zoom level each sample takes one pixel of the display (horizontally). That means one second of sound would take up 44100 pixels!</li>";
			helpText += "<li>At lower zoom levels each pixel shows the average of several samples. The amount is displayed above the waveform at 'samples per pixel'.</li>";
			helpText += "<li>The first and last sample in view on the display are shown at 'first sample' and 'last sample'.</li>";
			helpText += "<br><br>";
			
			mBody = asset.tBody;
			mBody.htmlText = helpText;
			mBody.addEventListener(Event.SCROLL, textScrollHandler);
			
			mScrollBar = new VScrollBar(asset.tScrollBar);
			mScrollBar.setScrollProperties(mBody.bottomScrollV, 0, mBody.maxScrollV, 5);
			mScrollBar.addEventListener(Event.CHANGE, scrollBarChangeHandler);
		}

		/**
		 * 
		 */
		private function scrollBarChangeHandler(inEvent : Event) : void
		{
			mBody.scrollV = mScrollBar.scrollPosition;
		}

		/**
		 * 
		 */
		private function textScrollHandler(inEvent : Event) : void
		{
			mScrollBar.scrollPosition = mBody.scrollV;
		}

		/**
		 * 
		 */
		private function handleCloseClick(inEvent : MouseEvent) : void
		{
			hide();
		}
	}
}
