package com.hisschemoller.view.components 
{
	import assets.LoadPanelAsset;
	
	import com.hisschemoller.view.components.base.Component;
	import com.hisschemoller.view.components.base.PushButton;
	
	import flash.display.DisplayObjectContainer;
	import flash.events.Event;
	import flash.events.MouseEvent;	
	/**
	 * @author Wouter Hisschemoller
	 * (c) Oct 2, 2009
	 */
	public class LoadPanel extends Component 
	{
		public static const LOAD_BUTTON_CLICK : String = "loadButtonClick";
		public static const HELP_BUTTON_CLICK : String = "helpButtonClick";
		private var mLoadButton : PushButton;
		private var mHelpButton : PushButton;
		private var mHelp : Help;
		
		public function LoadPanel(inContainer : DisplayObjectContainer)
		{
			super(inContainer, new LoadPanelAsset());
		}

		/**
		 * 
		 */
		override protected function addChildren() : void
		{
			mLoadButton = new PushButton(asset.tLoadButton);
			mLoadButton.addEventListener(MouseEvent.CLICK, handleLoadClick);
			
			mHelpButton = new PushButton(asset.tHelpButton);
			mHelpButton.addEventListener(MouseEvent.CLICK, handleHelpClick);
			
			mHelp = new Help(mAsset);
			mHelp.hide();
		}

		/**
		 * 
		 */
		private function handleHelpClick(inEvent : MouseEvent) : void
		{
			mHelp.show();
		}

		/**
		 * 
		 */
		private function handleLoadClick(inEvent : MouseEvent) : void
		{
			dispatchEvent(new Event(LoadPanel.LOAD_BUTTON_CLICK));
		}

		/**
		 * 
		 */
		private function get asset() : LoadPanelAsset
		{
			return mAsset as LoadPanelAsset;
		}
	}
}
