package com.hisschemoller.view.components 
{
	import com.hisschemoller.view.components.base.Component;
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;	
	/**
	 * (c) Copyright LBi Lost Boys 2009
	 * @author wouter.hisschemoller
	 * 
	 * When the mouse is dragged up or down on the display the wave zooms in or out.
	 * When it's dragged left or right the wave scrolls.
	 */
	public class WaveDisplay extends Component 
	{
		public static const MOUSE_DRAG : String = "mouseDrag";
		private var mWaveBitmap : Bitmap;
		private var mMouseIsDown : Boolean;

		public function WaveDisplay(inAsset : MovieClip)
		{
			super(null, inAsset);
		}

		/**
		 * 
		 */
		public function set bitmapData(inBitmapData : BitmapData) : void
		{
			mWaveBitmap.bitmapData = inBitmapData;
		}

		/**
		 * 
		 */
		public function get mouseX() : Number
		{
			return mWaveBitmap.mouseX;
		}

		/**
		 * 
		 */
		public function get mouseY() : Number
		{
			return mWaveBitmap.mouseY;
		}

		/**
		 * 
		 */
		override protected function addChildren() : void
		{
			super.addChildren();
			
			mWaveBitmap = new Bitmap();
			mWaveBitmap.scaleX = 1 / mAsset.scaleX;
			mWaveBitmap.scaleY = 1 / mAsset.scaleY;
			mWaveBitmap.addEventListener(MouseEvent.MOUSE_DOWN, handleMouseDown);
			mAsset.addChild(mWaveBitmap);
			
			mAsset.addEventListener(MouseEvent.MOUSE_DOWN, handleMouseDown);
		}

		/**
		 * 
		 */
		private function handleMouseDown(inEvent : MouseEvent) : void
		{
			mMouseIsDown = true;
			
			mAsset.stage.addEventListener(MouseEvent.MOUSE_MOVE, handleMouseMove);
			mAsset.stage.addEventListener(MouseEvent.MOUSE_UP, handleMouseUp);
			
			dispatchEvent(inEvent);
		}

		/**
		 * 
		 */
		private function handleMouseMove(inEvent : MouseEvent) : void
		{
			if(mMouseIsDown)
			{
				dispatchEvent(new Event(WaveDisplay.MOUSE_DRAG));
			}
		}

		/**
		 * 
		 */
		private function handleMouseUp(inEvent : MouseEvent) : void
		{
			mMouseIsDown = false;
			
			mAsset.stage.removeEventListener(MouseEvent.MOUSE_MOVE, handleMouseMove);
			mAsset.stage.removeEventListener(MouseEvent.MOUSE_UP, handleMouseUp);
		}
	}
}
