package com.hisschemoller.view.components.base 
{
	import com.hisschemoller.view.components.base.Component;
	
	import flash.display.MovieClip;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;	
	/**
	 * (c) Copyright LBi Lost Boys 2009
	 * @author wouter.hisschemoller
	 */
	public class Label extends Component 
	{
		protected var mAutoSize : String = TextFieldAutoSize.LEFT;
		protected var mText : String = "";
		protected var mTextField : TextField;

		public function Label(inAsset : MovieClip, inText : String = "")
		{
			mText = inText;
			
			super(null, inAsset);
		}

		/**
		 * Draws the visual ui of the component.
		 */
		override public function draw() : void
		{
			super.draw();
			
			mTextField.text = mText;
			mTextField.autoSize = mAutoSize;
			
			mWidth = mTextField.width;
			mHeight = mTextField.height = 18;
		}

		/**
		 * Gets / sets the text of this Label.
		 */
		public function setText(inText : String) : void
		{
			mText = inText;
			invalidate();
		}

		public function getText() : String
		{
			return mText;
		}

		/**
		 * Gets / sets whether or not this Label will autosize.
		 */
		public function setAutoSize(inAutoSize : String) : void
		{
			mAutoSize = inAutoSize;
		}

		public function getAutoSize() : String
		{
			return mAutoSize;
		}

		/**
		 * Initializes the component.
		 */
		override protected function init() : void
		{
			super.init();
			
			mAsset.mouseEnabled = false;
		}
	}
}
