package com.hisschemoller.view.components.base 
{
	import com.hisschemoller.view.components.base.Component;
	
	import org.asaplibrary.ui.buttons.ButtonBehavior;
	import org.asaplibrary.ui.buttons.ButtonBehaviorEvent;
	import org.asaplibrary.ui.buttons.ButtonStates;
	
	import flash.display.DisplayObjectContainer;
	import flash.display.MovieClip;
	import flash.events.MouseEvent;	
	/**
	 * (c) Copyright LBi Lost Boys 2009
	 * @author wouter.hisschemoller
	 */
	public class PushButton extends Component 
	{
		protected static const LABEL_UP : String = "up";
		protected static const LABEL_OVER : String = "over";
		protected static const LABEL_DOWN : String = "down";
		private var mBehavior : ButtonBehavior;

		public function PushButton(inAsset : MovieClip)
		{
			super(null, inAsset);
		}

		/**
		 * Initializes the component.
		 */
		override protected function init() : void
		{
			mAsset.stop();
			mAsset.buttonMode = true;
			mAsset.useHandCursor = true;
			mAsset.mouseChildren = false;
			mAsset.addEventListener(MouseEvent.CLICK, handleMouseClick);
			
			mBehavior = new ButtonBehavior(mAsset);
			mBehavior.addEventListener(ButtonBehaviorEvent._EVENT, update);
		}

		/**
		 * 
		 */
		private function update(inEvent : ButtonBehaviorEvent) : void
		{
			switch(inEvent.state)
			{
				case ButtonStates.UP:
				case ButtonStates.OVER:
					mAsset.gotoAndStop(PushButton.LABEL_OVER);
					break;
				case ButtonStates.OUT:
				case (ButtonStates.UP + ButtonStates.OUT):
					mAsset.gotoAndStop(PushButton.LABEL_UP);
					break;
				case ButtonStates.DOWN:
					mAsset.gotoAndStop(PushButton.LABEL_DOWN);
					break;
			}
		}

		/**
		 * 
		 */
		private function handleMouseClick(inEvent : MouseEvent) : void
		{
			dispatchEvent(new MouseEvent(MouseEvent.CLICK));
		}
	}
}
